package com.ibm.mqe.bridgemodel;

/****************************************************************************/
/*                                                                          */
/* Program name: MQ Series Everyplace - Administration Tool                 */
/*                                                                          */
/*  Statement:  Licensed Materials - Property of IBM                        */
/*                                                                          */
/*              MQSeries SupportPac MSE1                                    */
/*              (C) Copyright IBM Corp. 2000                                */
/*                                                                          */
/****************************************************************************/
/*                                                                          */
/* Change history:                                                          */
/*                                                                          */
/* V1.0   15-08-2000  PTvL  Initial release                                 */
/*                                                                          */
/*==========================================================================*/
import com.ibm.uia.renderingInterface.*;
import com.ibm.uia.metamodel.*;
import com.ibm.mqe.administration.*;
import com.ibm.mqe.*;
import java.util.*;
import com.ibm.mqe.model.*;
import com.ibm.mqe.mqbridge.*;
/**
 * Insert the type's description here.
 * Creation date: (08/06/2000 14:49:45)
 * @author: Phill van Leersum
 */
public final class MQeBridgeQueueProxy extends AbstractRemoteQueue implements BridgeModelConstants {
	private static final String QM_NAME_ATTRIBUTE = "Queue Manager Name";
	private static final String BRIDGE_NAME_ATTRIBUTE = "Bridge Name";
	private static final String IDLE_TIMEOUT_ATTRIBUTE = "Max Idle Timeout";
	private static final String CLIENT_CONNECTION_ATTRIBUTE = "ClientConnection";
	private static final String REMOTE_QUEUE_NAME_ATTRIBUTE = "Remote Queue Name";
	
	private static final String CMD_ADD_QM = "Add QueueManager";
protected boolean _readRefreshData(MQeFields data, Vector found) {
	boolean reply = super._readRefreshData(data, found);
	return reply;
}
/**
 * Read the receivers initial data from the given String array.
 * This will be called when the parnt of the receiver is initialising
 * the receiver, and before the first refresh request.
 */
protected void initialiseFrom(String[] data) {
	setAttribute(CLIENT_CONNECTION_ATTRIBUTE, data[1]);
	setAttribute(QQMNAME_ATTR, data[2]);
	setAttribute(BRIDGE_NAME_ATTRIBUTE, data[3]);
	setAttribute(IDLE_TIMEOUT_ATTRIBUTE, data[4]);
}
public MQeQueueAdminMsg queueAdminMessage() {
	MQeQueueAdminMsg msg = null;
	try {

//		String qqmName = getAttributeValue(QQMNAME_ATTR);
		String bridgeName = getAttributeValue(BRIDGE_NAME_ATTRIBUTE);
		String connectionName = getAttributeValue(CLIENT_CONNECTION_ATTRIBUTE);
		int maxIdleTimeout = 5;
		String str = getAttributeValue(IDLE_TIMEOUT_ATTRIBUTE);
		try {
			maxIdleTimeout = Integer.parseInt(str);
		} catch (NumberFormatException e) {
		}

		msg = new MQeMQBridgeQueueAdminMsg(bridgeName, getQueueQueueManagerName(), connectionName, maxIdleTimeout);
		MQeFields params = msg.getInputFields();
		// set name of MQ queue
		params.putAscii(MQeMQBridgeQueueAdminMsg.Queue_RemoteQName, getName());
		//params.putAscii(MQeMQBridgeQueueAdminMsg.Queue_QMgrName, getQueueQueueManagerName());
		params.putByte(MQeMQBridgeQueueAdminMsg.Queue_Mode, MQeMQBridgeQueueAdminMsg.Queue_Synchronous);
		// The queue location is a mandatory parameter.
		params.putAscii(MQeMQBridgeQueueAdminMsg.Queue_FileDesc, "location:");
		//set name as known to MQe
		//msg.putFields(MQeAdminMsg.Admin_Parms, params);
		msg.setName(getQueueQueueManagerName(), getName());
	} catch (Exception e) {
		_error("error creating MQeBridgeQueueAdminMsg", e); 
	}
	return msg;
}
}
