package com.ibm.mqe.model;

import com.ibm.mqe.*;
import com.ibm.mqe.administration.*;
import java.util.*;
/**
 * Insert the type's description here.
 * Creation date: (10/9/2000 10:57:23 AM)
 * @author: 
 */
public class DirectQMStub extends MQeQueueManagerStub {
/**
 * DirectQMStub constructor comment.
 * @param listener com.ibm.mqe.stub.MQeStubMessageListener
 * @param adminQM com.ibm.mqe.stub.MQeAdministeringQM
 */
public DirectQMStub(MQeStubMessageListener listener, MQeQueueManager adminQM) {
	super(listener, adminQM);
}
/**
 * addTemporaryRoute method comment.
 */
public boolean[] addTemporaryRoute(String destination, String route) {
	return new boolean[]{true, false};
}
/**
 * browseQueue method comment.
 */
public MQeEnumeration browseQueue(String queueQueueManagerName, String queueName) {
	MQeEnumeration enum = null;
	try {
		enum = adminQM.browseMessages(
			queueQueueManagerName, queueName, null, null, false);
		
	} catch (Exception e) {
		_warning("Error browsing queue", e);
	}
	return enum;
}
/**
 * connect method comment.
 */
public boolean connect(String name, String route, int mode) {
	return true;
}
/**
 * createTemporaryRemoteQueue method comment.
 *
 * pretend that we have, so Model is oblivious to low level events
 */
public boolean[] createTemporaryRemoteQueue(String queueQueueManagerName, String queueName) {
	return new boolean[]{true, false};
}
/**
 * deleteMessage method comment.
 */
public boolean deleteMessage(String queueQueueManagerName, String queueName, MQeFields msg) {
	try {
		adminQM.deleteMessage(queueQueueManagerName, queueName, msg);
		return true;
	} catch (Exception e) {
		_warning("error deleting message from "+getName()+"/"+ getName(), e);
	}
	return false;
}
/**
 * deleteTemporaryRemoteQueue method comment.
 */
public void deleteTemporaryRemoteQueue(String queueQueueManagerName, String queueName) {}
/**
 * disconnect method comment.
 */
public boolean disconnect(boolean removeResources) {
	return true;
}
/**
 * isConnected method comment.
 */
public boolean isConnected() {
	return true;
}
/**
 * Place the given message on the local queue manager admin queue
 * and wait for a correlationIding reply message if required.
 * Reply the correlationIding message (or null).
 *
 * msg: message to send
 */
public final MQeAdminMsg putAdminMessage(MQeAdminMsg msg, MQeStubMessageListener listener) {
	String correlationId = null;
	try {
		correlationId = _addReplyRequest(msg, getName());
		msg.setTargetQMgr(getName());
		adminQM.putMessage(getName(), MQe.Admin_Queue_Name, msg, null, 0);
		return _waitForMessage(adminQM, getName(), correlationId);
	} catch (Exception e) {
		_error("Putting message: ", e);
	}
	return null;
}
/**
 * removeTemporaryRoute method comment.
 */
public void removeTemporaryRoute(String destination) {}
/**
 * testMessage method comment.
 */
public void testMessage(String queueQueueManagerName, String queueName, String txt) {
	try {
		MQeMsgObject msg = new MQeMsgObject();
		msg.putAscii("Contents", txt);
		adminQM.putMessage(queueQueueManagerName, queueName, msg, null, 0);
		
	} catch (Exception e) {
		_warning("Error placing test message", e);
	}
}
}
