package com.ibm.uia.metamodel;

/****************************************************************************/
/*                                                                          */
/* Program name: MQ Series Everyplace - Administration Tool                 */
/*                                                                          */
/*  Statement:  Licensed Materials - Property of IBM                        */
/*                                                                          */
/*              MQSeries SupportPac MSE1                                    */
/*              (C) Copyright IBM Corp. 2000                                */
/*                                                                          */
/****************************************************************************/
/*                                                                          */
/* Change history:                                                          */
/*                                                                          */
/* V1.0   15-08-2000  PTvL  Initial release                                 */
/*                                                                          */
/*==========================================================================*/
import java.util.*;
import com.ibm.uia.xml.*;
/**
 * This type was created in VisualAge.
 */
public class AttributeDefinition extends MetaModelComponent {
	public static final String ATTRIBUTE_DEFINITION = "attributeDefinition";
	protected static final String MAPPED_ATTRIBUTE_NAME = "mappedName";
	protected static final String ATTRIBUTE_TYPE = "type";
	protected static final String ATTRIBUTE_ISEDITABLE = "edit";
	protected static final String ATTRIBUTE_ISREQUIRED = "required";
	protected static final String ATTRIBUTE_DEFAULT = "default";
	private static final String TRUE = "true";
	private static final String FALSE = "false";
	
	private MetaObject metaObject;
	private String defaultValue;
	private boolean editable;
	private boolean required;
	private String typeName;
	private String mappedName;
/**
 * AttributeDefinition constructor comment.
 * NOTE: we remove the dom attributes we use, so that
 * subclass implementations can ignore them
 */
protected AttributeDefinition(MetaObject metaObject) {
	super();
	this.metaObject = metaObject;
}
final String _getDefaultValue() {
	if (null == defaultValue) {
		return getType().getDefaultValue();
	}
	return defaultValue;
}
final boolean _isEditable() {
	return editable;
}
final boolean _isNameAttribute() {
	return false; //MetaModel.NAMEATTRIBUTE_TAG_TEXT.equals(name);
}
final boolean _isRequired() {
	return required;
}
/**
 * create a DOM representation of the receiver using
 * the supplied document.  The Element generated should
 * be returned to the caller, and not appended to the 
 * document.  Subclasses can override this method but
 * are strongly recommended to call the superclass
 * method FIRST and decorate the returned element with their
 * specific data.
 * Note that the superclass is responsible for navigating
 * the standard tree structures, so this responsibility
 * is removed from subclass implementors
 */
protected Element generateDom(Document doc) {
	Element el = super.generateDom(doc);
	el.setAttribute(ATTRIBUTE_TYPE, getType().getName());
	el.setAttribute(ATTRIBUTE_ISEDITABLE, (_isEditable() ? TRUE : FALSE));
	el.setAttribute(ATTRIBUTE_ISREQUIRED, (_isRequired() ? TRUE : FALSE));
	String def = _getDefaultValue();
	if (null != def) {
		el.setAttribute(ATTRIBUTE_DEFAULT, def);
	}
	return el;
}
public final String getMappedName() {
	return mappedName;
}
public final MetaModel getMetaModel() {
	return metaObject.getMetaModel();
}
public final MetaObject getMetaObject() {
	return metaObject;
}
/**
 * Reply the string used to identify an XML tag as representing
 * an instance of the receivers class
 */
public final String getTagName() {
	return ATTRIBUTE_DEFINITION;
}
public final AttributeType getType() {
	return getMetaModel().getType(typeName);
}
protected Attribute newAttribute(UIObject owner) {
	return new Attribute(this, owner);
}
/**
 * Initialise the receiver from the given Element.
 */ 
protected void parseDom(Element element) {
	super.parseDom(element);
	typeName = element.getAttribute(ATTRIBUTE_TYPE);
	element.removeAttribute(ATTRIBUTE_TYPE);
	mappedName = element.getAttribute(MAPPED_ATTRIBUTE_NAME);

	String str = element.getAttribute(ATTRIBUTE_ISEDITABLE);
	if (null != str && str.length() > 0) {
		element.removeAttribute(ATTRIBUTE_ISEDITABLE);
		editable = TRUE.equals(str);
	} else {
		editable = true;
	}

	str = element.getAttribute(ATTRIBUTE_ISREQUIRED);
	if (null != str && str.length() > 0) {
		element.removeAttribute(ATTRIBUTE_ISREQUIRED);
		required = TRUE.equals(str);
	} else {
		required = false;
	}
	
	str = element.getAttribute(ATTRIBUTE_DEFAULT);
	if (null != str && str.length() > 0) {
		element.removeAttribute(ATTRIBUTE_DEFAULT);
		defaultValue = str;
	}
}
}
