package com.ibm.uia.renderer;

/****************************************************************************/
/*                                                                          */
/* Program name: MQ Series Everyplace - Administration Tool                 */
/*                                                                          */
/*  Statement:  Licensed Materials - Property of IBM                        */
/*                                                                          */
/*              MQSeries SupportPac MSE1                                    */
/*              (C) Copyright IBM Corp. 2000                                */
/*                                                                          */
/****************************************************************************/
/*                                                                          */
/* Change history:                                                          */
/*                                                                          */
/* V1.0   15-08-2000  PTvL  Initial release                                 */
/*                                                                          */
/*==========================================================================*/
import java.awt.*;
import java.awt.event.*;

/**
 * Insert the type's description here.
 * Creation date: (19/05/2000 13:24:42)
 * @author: Phill van Leersum
 */
public class GetStringsDialogue extends RendererDialogue implements ActionListener, WindowListener {
	private static final String OK = "Ok";
	private static final String CANCEL = "Cancel";
	private TextField[] dataFields;
	private boolean okPressed = false;
/**
 * AddQmDialogue constructor comment.
 * @param parent java.awt.Frame
 */
public GetStringsDialogue(java.awt.Frame parent, String title, String[] fields, String[] defaults) {
	super(parent, title);
	addWindowListener(this);
	setLayout(new BorderLayout());

	Panel dataPanel = new Panel(new GridLayout(0,2));

	dataFields = new TextField[fields.length];
	for (int i = 0; i < fields.length; i++){
		dataPanel.add(new Label(fields[i]));
		if (null != defaults && defaults.length > i && null != defaults[i]) {
			dataFields[i] = new TextField(defaults[i]);
		} else {
			dataFields[i] = new TextField(30);
		}
		dataPanel.add(dataFields[i]);
	}
	add("Center", dataPanel);
	
	Panel buttonPanel = new Panel(new FlowLayout(FlowLayout.CENTER));
	Button button = new Button(OK);
	button.addActionListener(this);
	buttonPanel.add(button);
	button = new Button(CANCEL);
	button.addActionListener(this);
	buttonPanel.add(button);
	add("South", buttonPanel);

	pack();
}
public void actionPerformed(ActionEvent e) {
	String cmd = e.getActionCommand();
	if (OK.equals(cmd)) {
		okPressed = true;
	}
	setVisible(false);
}
public final String[] getData() {
	String[] reply = new String[dataFields.length];
	for (int i = 0; i < reply.length; i++){
		reply[i] = dataFields[i].getText();
	}
	return reply;
}
protected boolean okPressed() {
	return okPressed;
}
/**
 * windowActivated method comment.
 */
public void windowActivated(java.awt.event.WindowEvent e) {
}
/**
 * windowClosed method comment.
 */
public void windowClosed(java.awt.event.WindowEvent e) {
}
/**
 * windowClosing method comment.
 */
public void windowClosing(java.awt.event.WindowEvent e) {
	setVisible(false);
}
/**
 * windowDeactivated method comment.
 */
public void windowDeactivated(java.awt.event.WindowEvent e) {
}
/**
 * windowDeiconified method comment.
 */
public void windowDeiconified(java.awt.event.WindowEvent e) {
}
/**
 * windowIconified method comment.
 */
public void windowIconified(java.awt.event.WindowEvent e) {
}
/**
 * windowOpened method comment.
 */
public void windowOpened(java.awt.event.WindowEvent e) {
}
}
