package com.ibm.uia.renderer;

/****************************************************************************/
/*                                                                          */
/* Program name: MQ Series Everyplace - Administration Tool                 */
/*                                                                          */
/*  Statement:  Licensed Materials - Property of IBM                        */
/*                                                                          */
/*              MQSeries SupportPac MSE1                                    */
/*              (C) Copyright IBM Corp. 2000                                */
/*                                                                          */
/****************************************************************************/
/*                                                                          */
/* Change history:                                                          */
/*                                                                          */
/* V1.0   15-08-2000  PTvL  Initial release                                 */
/*                                                                          */
/*==========================================================================*/
import com.ibm.uia.renderingInterface.*;
import java.awt.*;
import java.awt.event.*;
import java.util.*;

/**
 * This type was created in VisualAge.
 */
public class ListPanel extends ComponentPanel {
/**
 * RenderPanel constructor comment.
 */
public ListPanel(RendererPanel renderer) {
	super(renderer);
}
protected void _doubleClicked(RendererNode rn) {
	if (null != rn) {
		if (rn instanceof RendererTreeNode) {
			rendererPanel.listDoubleClicked(rn);
		}
	}
}
final void recalculate(boolean recurse) {
	RendererTreeNode rtn = rendererPanel.getTreeSelectedNode();
	if (null == rtn) {
		rootNodes = new Vector();
	} else {
		RenderableObject ro = rtn.getRenderableObject();
		rootNodes = (Vector) rtn.getChildNodeVector().clone();
		Enumeration attrs = sorted(ro.getAllAttributes());
		
		while (attrs.hasMoreElements()) {
			RenderableAttribute ra = (RenderableAttribute) attrs.nextElement();
			rootNodes.addElement(new RendererAttributeNode(ra));
		}
	}
}
public static final Enumeration sorted(Enumeration enum) {
	Vector v = new Vector();
	if (enum.hasMoreElements()) {
		v.addElement(enum.nextElement());
	}
	while (enum.hasMoreElements()) {
		Renderable newComp = (Renderable)enum.nextElement();
		String newName = newComp.getName();
		boolean inserted = false;
		for (int i = 0; i < v.size() && !inserted; i++) {
			Renderable oldComp = (Renderable)v.elementAt(i);
			if (oldComp.getName().compareTo(newName) >= 0) {
				v.insertElementAt(newComp, i);
				inserted = true;
			}
		}
		if (!inserted) {
			v.addElement(newComp);
		}
	}
	return v.elements();
}
}
