package com.ibm.uia.renderer;

/****************************************************************************/
/*                                                                          */
/* Program name: MQ Series Everyplace - Administration Tool                 */
/*                                                                          */
/*  Statement:  Licensed Materials - Property of IBM                        */
/*                                                                          */
/*              MQSeries SupportPac MSE1                                    */
/*              (C) Copyright IBM Corp. 2000                                */
/*                                                                          */
/****************************************************************************/
/*                                                                          */
/* Change history:                                                          */
/*                                                                          */
/* V1.0   15-08-2000  PTvL  Initial release                                 */
/*                                                                          */
/*==========================================================================*/
import com.ibm.uia.renderingInterface.*;
import java.awt.*;
import java.awt.event.*;
import java.util.*;
/**
 * This type was created in VisualAge.
 */
public class MultipleAttributeEditPanel extends Panel {
	public static final int NON_EDIT = 0;
	public static final int COMMIT_DEFFERRED = 1;
	public static final int COMMIT_ON_CHANGE = 2;
	private Vector attributeEditors;
/**
 * RenderPanel constructor comment.
 */
public MultipleAttributeEditPanel(int mode) {
	super(new GridBagLayout());
	//setAttributes(attributeEnum, mode);
}
/**
 * RenderPanel constructor comment.
 */
public MultipleAttributeEditPanel(Enumeration attributeEnum, ActionListener listener) {
	super(new GridBagLayout());
	setAttributes(attributeEnum, listener);
}
protected void addComponent(Component component, int gridx, int gridy) {
	GridBagConstraints c = new GridBagConstraints();
	c.gridx = gridx;
	c.gridy = gridy;
	c.gridwidth = 1;
	c.gridheight = 1;
	c.weightx = 1;
	c.weighty = 0;
	c.fill = GridBagConstraints.HORIZONTAL;
	c.anchor = GridBagConstraints.NORTHWEST;
	((GridBagLayout)getLayout()).setConstraints(component, c);
	add(component);
}
protected void addLabel(String text, int gridx, int gridy) {
	Label label = new Label(text);
	GridBagConstraints c = new GridBagConstraints();
	c.gridx = gridx;
	c.gridy = gridy;
	c.gridwidth = 1;
	c.gridheight = 1;
	c.weightx = 0;
	c.weighty = 0;
	c.fill = GridBagConstraints.NONE;
	c.anchor = GridBagConstraints.NORTHWEST;
	((GridBagLayout)getLayout()).setConstraints(label, c);
	add(label);
}
public void commit() {
	Enumeration enum = attributeEditors.elements();
	while (enum.hasMoreElements()) {
		((SingleAttributeEditPanel)enum.nextElement()).commit();
	}
}
public void reset() {
	Enumeration enum = attributeEditors.elements();
	while (enum.hasMoreElements()) {
		((SingleAttributeEditPanel)enum.nextElement()).resetValues();
	}
}
/**
 * RenderPanel constructor comment.
 */
public final void setAttributes(Enumeration attributeEnum, ActionListener listener) {
	attributeEditors = new Vector();
	removeAll();
	int i = 0;
	while (attributeEnum.hasMoreElements()) {
		RenderableAttribute ra = (RenderableAttribute)attributeEnum.nextElement();
		SingleAttributeEditPanel saep = new SingleAttributeEditPanel(ra, listener);
		addLabel(ra.getName(), 0, i);
		addComponent(saep, 1, i);
		attributeEditors.addElement(saep);
		i++;
	}
	validate();
}
}
