package com.ibm.uia.renderingInterface;

/****************************************************************************/
/*                                                                          */
/* Program name: MQ Series Everyplace - Administration Tool                 */
/*                                                                          */
/*  Statement:  Licensed Materials - Property of IBM                        */
/*                                                                          */
/*              MQSeries SupportPac MSE1                                    */
/*              (C) Copyright IBM Corp. 2000                                */
/*                                                                          */
/****************************************************************************/
/*                                                                          */
/* Change history:                                                          */
/*                                                                          */
/* V1.0   15-08-2000  PTvL  Initial release                                 */
/*                                                                          */
/*==========================================================================*/
import java.util.*;
/**
 * This interface marks a class as renderable.
 */
public interface RenderableOperation extends Renderable {
public abstract String[] getData();
/**
 * Reply an enumeration of the elements of the display path
 * representing the operation.  This allows for organised
 * menus, grouped buttons etc.
 *  eg file, new, letter
 * If there are no path elements then an empty enumeration 
 * will be returned.
 * Example.  In the operation:
 * 		file.new.Letter
 * the strings 'file' and 'new' are path elements.  'Letter' is the 
 * operation name.
 */
public abstract Enumeration getDisplayPath();
/**
 * Reply the string used to represent the receiver in
 * the gui
 */
public abstract String getName();
public abstract boolean isEnabled();
public abstract boolean isToggle();
public abstract boolean perform(Renderer renderer);
}
